package de.jottyfan.timetrack.spring.done.project;

import javax.annotation.security.RolesAllowed;
import javax.servlet.http.HttpServletRequest;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import de.jottyfan.timetrack.db.done.tables.records.TProjectRecord;
import de.jottyfan.timetrack.spring.done.DoneController;
import de.jottyfan.timetrack.spring.done.DoneModel;

/**
 * 
 * @author henkej
 *
 */
@Controller
public class ProjectController {
	private static final Logger LOGGER = LogManager.getLogger(ProjectController.class);
	
	@Autowired
	private IProjectService projectService;

	@Autowired
	private DoneController doneController;
	
	@RolesAllowed("timetrack_user")
	@GetMapping("/done/edit/project/{id}")
	public String toProject(@PathVariable Integer id, Model model) {
		TProjectRecord project = projectService.get(id);
		model.addAttribute("projectBean", project);
		return "done/project";
	}
	
	@RolesAllowed("timetrack_user")
	@RequestMapping(value = "/done/upsert/project", method = RequestMethod.POST)
	public String doUpsert(Model model, @ModelAttribute TProjectRecord bean) {
		Integer amount = projectService.doUpsert(bean);
		return amount.equals(1) ? doneController.getList(new DoneModel(), model) : toProject(bean.getPk(), model);
	}

	@RolesAllowed("timetrack_user")
	@RequestMapping(value = "/done/add/project", method = RequestMethod.GET)
	public String toAddProject(Model model) {
		return toProject(null, model);
	}

	@RolesAllowed("timetrack_user")
	@GetMapping(value = "/done/delete/project/{id}")
	public String doDeleteProject(@PathVariable Integer id, Model model) {
		Integer amount = projectService.doDelete(id);
		return amount.equals(1) ? doneController.getList(new DoneModel(), model) : toProject(id, model);
	}
}
